#include "stm32f10x.h"

__IO uint16_t count;

int main(void){
   RCC->APB2ENR = RCC_APB2ENR_IOPAEN;
   RCC->APB1ENR = RCC_APB1ENR_TIM6EN;
   GPIOA->CRL = 0x22222222;    /* PA0-7 2MHz out      */
   NVIC_EnableIRQ(TIM6_IRQn);
   TIM6->PSC = 1 << 12;        /* 4 MHz -> 1 KHz      */
   TIM6->ARR = 1 << 8;         /* 4 Hz               */
   TIM6->DIER = TIM_DIER_UIE;  /* interrupt on update */
   TIM6->CR1 = TIM_CR1_CEN;    /* enable */
   while (1) {
      GPIOA->ODR = count;
   }
   /* return 0; */
}

void TIM6_IRQHandler(void){
   TIM6->SR = 0;
   count++;
}

